#include "common.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif

int
LLVMFuzzerTestOneInput(const uint8_t *data, size_t size) {
    size_t i = 0;

    int32_t int32_eq_const_0_0;
    int8_t int8_eq_const_1_0;
    int64_t int64_eq_const_2_0;
    int16_t int16_eq_const_3_0;
    int16_t int16_eq_const_4_0;
    int32_t int32_eq_const_5_0;
    int32_t int32_eq_const_6_0;
    int64_t int64_eq_const_7_0;
    int8_t int8_eq_const_8_0;
    int64_t int64_eq_const_9_0;
    int32_t int32_eq_const_10_0;
    int64_t int64_eq_const_11_0;

    if (size < 54)
        return TEPHRA_EXIT_FAILURE;


    memcpy(&int32_eq_const_0_0, &data[i], 4);
    i += 4;
    memcpy(&int8_eq_const_1_0, &data[i], 1);
    i += 1;
    memcpy(&int64_eq_const_2_0, &data[i], 8);
    i += 8;
    memcpy(&int16_eq_const_3_0, &data[i], 2);
    i += 2;
    memcpy(&int16_eq_const_4_0, &data[i], 2);
    i += 2;
    memcpy(&int32_eq_const_5_0, &data[i], 4);
    i += 4;
    memcpy(&int32_eq_const_6_0, &data[i], 4);
    i += 4;
    memcpy(&int64_eq_const_7_0, &data[i], 8);
    i += 8;
    memcpy(&int8_eq_const_8_0, &data[i], 1);
    i += 1;
    memcpy(&int64_eq_const_9_0, &data[i], 8);
    i += 8;
    memcpy(&int32_eq_const_10_0, &data[i], 4);
    i += 4;
    memcpy(&int64_eq_const_11_0, &data[i], 8);
    i += 8;


    if (int32_eq_const_0_0 == -2035850503)
    if (int8_eq_const_1_0 == -1)
    if (int64_eq_const_2_0 == -4775230764096107727)
    if (int16_eq_const_3_0 == -7769)
    if (int16_eq_const_4_0 == 7346)
    if (int32_eq_const_5_0 == 640325422)
    if (int32_eq_const_6_0 == 836106860)
    if (int64_eq_const_7_0 == -3410156167797438098)
    if (int8_eq_const_8_0 == -29)
    if (int64_eq_const_9_0 == -1501843754440404881)
    if (int32_eq_const_10_0 == -494090970)
    if (int64_eq_const_11_0 == 5111700023705331827)
        BOOM();

    return TEPHRA_EXIT_SUCCESS;
}

#ifdef __cplusplus
}
#endif
